/*
   3D Barriers

   barrier.h

   (c)2002 Paul Boese
*/

#ifndef __BARRIER_H
#define __BARRIER_H

#include "common.h"

class Barrier;

class Barrier {
	private:
		int mode;
		int id;

		static int refcnt;
		int pieces;
		int breaking;
		float saved_z;
		float rotf;
		float rots;
		
		float distance;
		point_t position;

		void draw_active();

		int draw_breaking();

		void sphere(float radius, int slices, int stacks);

	public:
		Barrier(); 

		point_t * Pos() {
			return &position;
		}

		void Hit();

		int Active();

		void Reset(point_t *pos);

		void Draw(point_t * pos);
};

#endif /* __BARRIER_H */
